Attribute VB_Name = "Module1"
Sub Main()
   Dim oServiceManager As Object
   Dim oDesktop As Object
   ' Get the Service Manager object.
   Set oServiceManager = _
       CreateObject("com.sun.star.ServiceManager")
   ' Get the Desktop object.
   Set oDesktop = _
       oServiceManager.createInstance("com.sun.star.frame.Desktop")
   ' Create DAO objects
   Dim odbcDB As DAO.Database
   Dim odbcRecordset As DAO.Recordset
   Dim defWSpace As Workspace
   Dim odbcServer As String
   Dim DataSet As String
   Dim odbcField As Object
   ' Set file and database folder values
   DataSet = "shelp.class"
   odbcServer = "sasuser32"
   ' Get default workspace.
   Set defWSpace = DBEngine.Workspaces(0)
   ' Set initialization properties
   Set odbcDB = defWSpace.OpenDatabase(odbcServer, _
                                       False, _
                                       True, _
                                       "ODBC;")
   ' Open recordset
   Set odbcRecordset = odbcDB.OpenRecordset(DataSet)
'--------------------------------------
' Common
'--------------------------------------
   Dim row As Long
   Dim column As Long
   ' Use this empty array when no arguments are needed.
   Dim aNoArgs()
'--------------------------------------
' OpenOffice.org Calc
'--------------------------------------
   Dim oCalcDoc As Object
   Dim oSheet As Object
   ' Create a new empty spreadsheet.
   Set oCalcDoc = _
     oDesktop.loadComponentFromURL("private:factory/scalc", _
                                   "_blank", 0, aNoArgs())
   ' Get the first spreadsheet from the sheets in the document.
   Set oSheet = oCalcDoc.getSheets().getByIndex(0)
   ' Write table to Calc sheet
   'this loop copies each field name into the 1st row of the sheet
   row = 0
   For column = 0 To (odbcRecordset.Fields.Count - 1)
     Set odbcField = odbcRecordset.Fields(column)
     oSheet.getCellByPosition(column, 0).setFormula _
           CStr(odbcField.Name)
   Next
   While odbcRecordset.EOF = False
     row = row + 1
     'this loop copies the data from each field to the new table
     For column = 0 To (odbcRecordset.Fields.Count - 1)
       Set odbcField = odbcRecordset.Fields(column)
       If odbcField.Type = 4 Or odbcField.Type = 7 Then
         oSheet.getCellByPosition(column, row).setValue _
               odbcField.Value
       Else
         oSheet.getCellByPosition(column, row).setFormula _
               CStr(odbcField.Value)
       End If
     Next
     odbcRecordset.MoveNext
   Wend
'--------------------------------------
' OpenOffice.org Writer
'--------------------------------------
   Dim oText As Object
   Dim oText2 As Object
   Dim oTable As Object
   Dim oCursor As Object
   ' Create a new blank text document.
   Set oText = _
          oDesktop.loadComponentFromURL("private:factory/swriter", _
                                        "_blank", 0, aNoArgs())
   ' insert TextTable
   Set oTable = oText.createInstance("com.sun.star.text.TextTable")
   ' Create position cursor
   Set oText2 = oText.GetText()
   Set oCursor = oText2.createTextCursor()
   ' Write table to Text doc
   ' initialise the table with the correct number of columns + rows
   oTable.Initialize 1, CLng(odbcRecordset.Fields.Count)
   oTable.RepeatHeadline = True
   ' insert table now
   oCursor.gotoStart False
   oText2.insertTextContent oCursor, oTable, False
   'this loop copies each field name into the 1st row of the table
   row = 0
   For column = 0 To (odbcRecordset.Fields.Count - 1)
     Set odbcField = odbcRecordset.Fields(column)
     oTable.getCellByPosition(column, 0).String = _
          CStr(odbcField.Name)
   Next
   odbcRecordset.MoveFirst
   While odbcRecordset.EOF = False
     row = row + 1
     oTable.GetRows().insertByIndex row, 1
     'this loop copies the data from each field to the new table
     For column = 0 To (odbcRecordset.Fields.Count - 1)
       Set odbcField = odbcRecordset.Fields(column)
       oTable.getCellByPosition(column, row).String = _
            CStr(odbcField.Value)
     Next
     odbcRecordset.MoveNext
   Wend
'--------------------------------------
' The following code is common to both processes,
' and should be included after the application-specific code:
'--------------------------------------
   ' Close connection
   odbcRecordset.Close
   odbcDB.Close
   Set defWSpace = Nothing
End Sub
